#!/usr/bin/perl --
# MonArch - Groundwork Monitor Architect
# monarch.cgi
#
###############################################################################
# Release 1.0
# 6-Jul-2006
###############################################################################
# Author: Folkerd Koning
#
# Copyright (C) 2006
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License version 2
# as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
###############################################################################
# Authors note:
#
# I wrote this little script to be able to modify the status map and see what
# I was doing while doing it. It's a bit crude and can certainly be improved
# upon, but for me it does what it needs. I'm using a small library I found
# on the net to emulate the <canvas> object for IE, using VML. Slightly modified
# it to get image support. Unfortunately, there's no way I know of to get the
# host labels on the canvas, I haven't been able to emulate a textbox through
# VML. If someone manages to pull that off, let me know.
# folkerd.koning@ci.ft-wayne.in.us
# Project: MonarchStatusMap
# Coding time: About 25 lunchbreaks
#
# On the wishlist:
# - Get hostnames on the map
# - Split map and top command structure in frames, only reloading the bottom
#   when needed.
#
###############################################################################
use lib qq(/usr/local/groundwork/monarch/lib);
use strict;
use CGI;
use MonarchForms;
use MonarchStorProc;
use MonarchDoc;
use URI::Escape;
$|++;

print "Content-type: text/html\n\n";

my $user_acct;
my $auth = StorProc->dbconnect();
if ($auth == 1) { 
	$user_acct = 'super_user';
}

my %myhosts = StorProc->get_hosts();
my %hostparents;
my %hostimgs;
my %hostcoords;

my $myhostname;
my $hostid;
my $curX;
my $curY;

my %urlValues =  split(/[&=]/, $ENV{'QUERY_STRING'});

if (defined($urlValues{'newX'})) {
	# User requested new coords for a host.
	my $xml_begin = "<?xml version=\"1.0\" ?>\n<data>\n";
	my $xml_end = "</data>";
	$myhostname = $urlValues{'SelHost'};
	my %data;
	$data{'2d_coords'} = "$urlValues{'newX'},$urlValues{'newY'}";
	StorProc->delete_all('extended_info_coords','host_id',$myhosts{$myhostname});
	if ($data{'2d_coords'}) {
		my $data_xml = $xml_begin;
		foreach my $d (keys %data) {
			if ($d =~ /coords/) {
				$data_xml .= " <prop name=\"$d\"><![CDATA[$data{$d}]]>\n";				
				$data_xml .= " </prop>\n";
			}
		}	
		$data_xml .= $xml_end;
		my @vals = ($myhosts{$myhostname},$data_xml);
		StorProc->insert_obj('extended_info_coords',\@vals);	
	}
}

my $maxX = 0;
my $maxY = 0;
$curX = 0;
$curY = 0;
my $SelectedHost;

#Gather host data.
while (($myhostname,$hostid) = each(%myhosts)){
	#grab the info for each host.
	my $curimg = '/nagios2/images/logos/icon/router.png';
	my %curhost = StorProc->fetch_host($myhostname);
	my @coords;

	#Gather coords.
	$hostcoords{$hostid} = $curhost{'coords2d'};
	@coords = split(',',$hostcoords{$hostid});
	if ($maxX < @coords[0]){ $maxX = @coords[0];}
	if ($maxY < @coords[1]){ $maxY = @coords[1];}

	#Assign parents.
        $hostparents{$hostid} = $curhost{'parents'};

	#Assign image.
	my $imagePrefix = '/nagios2/images/logos/'; # Needs work: Read from cfg info.
	my %extData;
	my %where;
	$where{'name'} = "$curhost{'ext_info'}";
	%extData = StorProc->fetch_one_where('extended_host_info_templates',\%where);
	$hostimgs{$hostid} = "$imagePrefix$extData{'statusmap_image'}";
}
$maxX = $maxX + 60;
$maxY = $maxY + 60;


#Preserve selected item.

if (defined($urlValues{"SelHost"})) { 
	$SelectedHost = $urlValues{"SelHost"};

#	Get the X and Y for the selected host.
	my @coordscur;
	@coordscur = split(',',$hostcoords{$myhosts{$SelectedHost}});
	$curX = @coordscur[0];
	$curY = @coordscur[1];
};


print <<EndScripts;
	<html><head><title>Monarch Statusmap Editor</title>
	<style>v\:*{behavior:url(#default#VML);}</style>
	</head>
	<script type="text/javascript" src=/monarch/canvas.js> </script>
	<script>
		window.onload = function() { 
			var boxCurX = document.getElementById('CurX');
			var boxCurY = document.getElementById('CurY');
			var CurSelHost = document.getElementById('SelectedHost');

			boxCurX.value = $curX;
			boxCurY.value = $curY;
			CurSelHost.value = "$SelectedHost";

			
			ieCanvasInit();
			setTimeout('loadCanvas()',1000);
		}

		function refreshPage(){
		// Reloads the canvas, resizing as needed. Sadly, the only way you can do this properly. 
		// Canvas resizing not possible without a page reload.
			var theURL = new String(window.location);
			var temp = new Array();
			var CurSelHost = document.getElementById('SelectedHost');
			temp = theURL.split('?');		
			window.location = temp[0] + '?SelHost=' + CurSelHost.value
		}
		
		function clearCurXY(){
			var butXY =document.getElementById('SetXY');
			var boxCurX = document.getElementById('CurX');
			var boxCurY = document.getElementById('CurY');
			boxCurX.value='Reload';
			boxCurY.value='Reload';
			butXY.disabled='disabled';
			
		}	

		function setXY(){
			var theURL = new String(window.location);
			var temp = new Array();
			var CurSelHost = document.getElementById('SelectedHost');
			var boxCurX = document.getElementById('CurX');
			var boxCurY = document.getElementById('CurY');
			temp = theURL.split('?');		
			window.location = temp[0] + '?SelHost=' + CurSelHost.value + '&newX=' + boxCurX.value + '&newY=' + boxCurY.value;
		}

		function drawImageOnCanvas(ctx,image,x,y) {
			var theImg;
			theImg = new Image()
			theImg.src = image;
			ctx.drawImage(image,x-(theImg.width/2)+30,y-(theImg.height/2)+30)
		}
	
		function drawLineOnCanvas(ctx,xo,yo,xd,yd){
			ctx.beginPath();
			ctx.moveTo(xo+30,yo+30);
			ctx.lineTo(xd+30,yd+30);
			ctx.closePath();
			ctx.stroke();
		}
		function highlightCoords(ctx,x,y){
			ctx.fillStyle= '#0F0';
			ctx.beginPath();
			ctx.arc(x+30,y+30,30,0,Math.PI*2,true);
			ctx.fill();
			ctx.closePath();
			ctx.stroke();
		}
	function drawStatusMap(ctx){
		highlightCoords(ctx,$curX,$curY);
EndScripts

# Here the actual statusmap drawing commands are issued.
while (($myhostname,$hostid) = each(%myhosts)){
#	Print the links
	my $loop = 0;
	while(defined($hostcoords{$myhosts{$hostparents{$hostid}[$loop]}})){
		print "		drawLineOnCanvas(ctx,$hostcoords{$hostid},$hostcoords{$myhosts{$hostparents{$hostid}[$loop]}});\n";
		$loop++;
	}
}
while (($myhostname,$hostid) = each(%myhosts)){
#	Print the images
	print "		drawImageOnCanvas(ctx,'$hostimgs{$hostid}',$hostcoords{$hostid});\n";
}

print <<EndDrawScript;
	}

	function loadCanvas() {
		var canvas = document.getElementById('NagStatusmap');
		var ctx = canvas.getContext('2d');
		var boxCurX = document.getElementById('CurX');
		var boxCurY = document.getElementById('CurY');
		
		// Clear before redrawing
		ctx.fillStyle = '#FFF';
		ctx.fillRect(0,0,$maxX,$maxY);
		// Redraw.
		ctx.lineWidth = 1;
		drawStatusMap(ctx);
	}
	</script>	
	<body>
	<h2>Nagios User-defined Status Map Editor for Monarch</h2>
	<button onclick="refreshPage();">Reload</button>
	Selected Host: <SELECT NAME="SelectedHost" size="1" onChange="clearCurXY();">
EndDrawScript

#  Here we'll enter all hosts in the host listbox.
while (($myhostname,$hostid) = each(%myhosts)){
	print "		<Option Value=$myhostname>$myhostname</option>\n";
}

print <<EndMainBody;
	</SELECT>
	Object X: <INPUT TYPE=TEXT NAME="CurX" SIZE=6 VALUE=0></INPUT>
	Object Y: <INPUT TYPE=TEXT NAME="CurY" SIZE=6 VALUE=0></INPUT>
	<button name="SetXY" onclick="setXY();">Set X/Y</button>
	<canvas id="NagStatusmap" width="$maxX" height="$maxY"></canvas><br>
	</body>
EndMainBody

StorProc->dbdisconnect();

print "</html>\n";
